local LDB

local menu = {}
local startChar = {
	["AB"] = {
	},
	["CD"] = {
	},
	["EF"] = {
	},
	["GH"] = {
	},
	["IJ"] = {
	},
	["KL"] = {
	},
	["MN"] = {
	},
	["OP"] = {
	},
	["QR"] = {
	},
	["ST"] = {
	},
	["UV"] = {
	},
	["WX"] = {
	},
	["YZ"] = {
	}
}


local parent = CreateFrame('Frame')
local function pairsByKeys (startChar, f)
	local a = {}
		for n in pairs(startChar) do table.insert(a, n) end
		table.sort(a, f)
		local i = 0      -- iterator variable
		local iter = function ()   -- iterator function
			i = i + 1
			if a[i] == nil then return nil
			else return a[i], startChar[a[i]]
			end
		end
	return iter
end


local function UpdateDisplay()
	if lastpetIndex ~= nil then
		LDB.text = lastpetText
		LDB.icon = lastpetIcon
		local creatureID, creatureName, creatureSpellID, icon, issummoned = GetCompanionInfo("CRITTER", lastpetIndex)
		if creatureName ~= lastpetText then
			for i = 1, GetNumCompanions("CRITTER") do
			local creatureID, creatureName, creatureSpellID, icon, issummoned = GetCompanionInfo("CRITTER", i)
			if creatureName == lastpetText then
				lastpetIndex = i
			end
			end
		end
	end
	
	if fav1index ~= nil  then
		local creatureID, creatureName, creatureSpellID, icon, issummoned = GetCompanionInfo("CRITTER", fav1index)
		if creatureName ~= fav1name then
			for i = 1, GetNumCompanions("CRITTER") do
			local creatureID, creatureName, creatureSpellID, icon, issummoned = GetCompanionInfo("CRITTER", i)
			if creatureName == fav1name then
				fav1index = i
			end
			end
		end
	end
	if fav2index ~= nil  then
		local creatureID, creatureName, creatureSpellID, icon, issummoned = GetCompanionInfo("CRITTER", fav2index)
		if creatureName ~= fav2name then
			for i = 1, GetNumCompanions("CRITTER") do
			local creatureID, creatureName, creatureSpellID, icon, issummoned = GetCompanionInfo("CRITTER", i)
			if creatureName == fav2name then
				fav2index = i
			end
			end
		end
	end
	if fav3index ~= nil  then
		local creatureID, creatureName, creatureSpellID, icon, issummoned = GetCompanionInfo("CRITTER", fav3index)
		if creatureName ~= fav3name then
			for i = 1, GetNumCompanions("CRITTER") do
			local creatureID, creatureName, creatureSpellID, icon, issummoned = GetCompanionInfo("CRITTER", i)
			if creatureName == fav3name then
				fav3index = i
			end
			end
		end
	end
	
	for i = 1, GetNumCompanions("CRITTER") do
		local creatureID, creatureName, creatureSpellID, icon, issummoned = GetCompanionInfo("CRITTER", i)
		if issummoned and creatureName then
			LDB.text = format("|cff00ff00%s|r", creatureName)
			LDB.icon = icon
			lastpetText = creatureName
			lastpetIndex = i
			lastpetIcon = icon
			return
		end
	end
end

local function ModifiedClick(button, i)	
local creatureID, creatureName, creatureSpellID, icon, issummoned = GetCompanionInfo("CRITTER", i)
	if IsShiftKeyDown() then
		PickupCompanion("CRITTER", i)
	elseif IsAltKeyDown() and not IsControlKeyDown() then
		fav1index = i
		fav1name = creatureName
		fav1icon = icon
		DEFAULT_CHAT_FRAME:AddMessage(string.format("|cffffff00BrokerPets:|r %s added as favorite 1.", creatureName))
	elseif IsControlKeyDown() and not IsAltKeyDown() then
		fav2index = i
		fav2name = creatureName
		fav2icon = icon
		DEFAULT_CHAT_FRAME:AddMessage(string.format("|cffffff00BrokerPets:|r %s added as favorite 2.", creatureName))
	elseif IsControlKeyDown() and IsAltKeyDown() then
		fav3index = i
		fav3name = creatureName
		fav3icon = icon
		DEFAULT_CHAT_FRAME:AddMessage(string.format("|cffffff00BrokerPets:|r %s added as favorite 3.", creatureName))
	else
		CallCompanion("CRITTER", i)
	end
end

local function OnTooltipShow(self)
	self:AddLine('|cff00ffffBrokerPets|r')
	self:AddLine("<Right Click> to open pet list")
	self:AddLine("<Left Click> to summon/dismiss pet")
	self:AddLine("<Shift-Left Click> plugin to summon a random pet")
	self:AddLine("<Shift-Left Click> pet to pick it up")
	self:AddLine("<ALT-Click> pet to set as favorite 1")
	self:AddLine("<CTRL-Click> pet to set as favorite 2")
	self:AddLine("<CTRL-ALT-Click> pet to set as favorite 3")
	if GetNumCompanions("CRITTER") == 0 then
	self:AddLine("|cffff0000You have no pets|r")
	else
	self:AddLine(string.format("|cff00ff00You have %s pets|r", GetNumCompanions("CRITTER")))
	end
end

local function OnClick(self, button)
	if button == 'RightButton' then
		ToggleDropDownMenu(1, nil, parent, self, 0, 0)
	end
	if (IsShiftKeyDown() and button == 'LeftButton') then	
		SummonRandomCritter()
	end
	if (button == 'LeftButton' and not IsShiftKeyDown()) then	
		if lastpetIndex ~= nil then
			CallCompanion("CRITTER", lastpetIndex)
		end
	end	
end

local function CreateMenu(self, level)
	menu = wipe(menu)
	local firstChar
	if 	GetNumCompanions("CRITTER") <= 20 then
	for i = 1, GetNumCompanions("CRITTER") do
		local creatureID, creatureName, creatureSpellID, icon, issummoned = GetCompanionInfo("CRITTER", i)
		local isUsable, notEnoughMana = IsUsableSpell(creatureSpellID)
		local startTime, duration, isEnabled = GetCompanionCooldown("CRITTER", i)
		menu.text = creatureName
		menu.func = ModifiedClick
		menu.arg1 = i
		menu.notCheckable = 1
		menu.icon = icon
		menu.colorCode = "|cffffffff"
		if not isUsable then
			menu.colorCode = "|cff848484"
		end
		if duration > 1.5 then
			cooldown = floor(((startTime + duration) - GetTime()) / 60)
			cd = format("%d m", cooldown)
			if cooldown >= 60 then
				cd = format("%.1f h", (cooldown / 60))
			end
			menu.text = string.format('%s (%s)', creatureName, cd)
			menu.colorCode = "|cff848484"
		end
		if issummoned then
			menu.colorCode = "|cff00ff00"
		end
		UIDropDownMenu_AddButton(menu)
	end
	elseif GetNumCompanions("CRITTER") >= 21 then
	level = level or 1;
	if (level == 1) then
	for key, v in pairsByKeys(startChar) do
		menu.text = key
		menu.notCheckable = 1
		menu.hasArrow = true;
		menu.value = {
			["Level1_Key"] = key;
		};
	
		UIDropDownMenu_AddButton(menu, level)
	end
		if fav1index ~= nil then
		local creatureID, creatureName, creatureSpellID, icon, issummoned = GetCompanionInfo("CRITTER", fav1index)
		local isUsable, notEnoughMana = IsUsableSpell(creatureSpellID)
		local startTime, duration, isEnabled = GetCompanionCooldown("CRITTER", fav1index)	
			menu.text = format ("1. %s", fav1name)
			menu.icon = fav1icon
			menu.colorCode = "|cffffffff"
			menu.func = ModifiedClick
			menu.arg1 = fav1index
			menu.hasArrow = nil;
			menu.notCheckable = 1
			if not isUsable then
				menu.colorCode = "|cff848484"
			end
			if duration > 1.5 then
				cooldown = floor(((startTime + duration) - GetTime()) / 60)
				cd = format("%d m", cooldown)
				if cooldown >= 60 then
					cd = format("%.1f h", (cooldown / 60))
				end
				menu.text = string.format('1. %s (%s)', creatureName, cd)
				menu.colorCode = "|cff848484"
			end
			if issummoned then
				menu.colorCode = "|cff00ff00"
			end
			UIDropDownMenu_AddButton(menu, level)
		end
		if fav2index ~= nil then
		local creatureID, creatureName, creatureSpellID, icon, issummoned = GetCompanionInfo("CRITTER", fav2index)
		local isUsable, notEnoughMana = IsUsableSpell(creatureSpellID)
		local startTime, duration, isEnabled = GetCompanionCooldown("CRITTER", fav2index)	
			menu.text = format("2. %s", fav2name)
			menu.icon = fav2icon
			menu.colorCode = "|cffffffff"
			menu.func = ModifiedClick
			menu.arg1 = fav2index
			menu.hasArrow = nil;
			menu.notCheckable = 1
			if not isUsable then
				menu.colorCode = "|cff848484"
			end
			if duration > 1.5 then
				cooldown = floor(((startTime + duration) - GetTime()) / 60)
				cd = format("%d m", cooldown)
				if cooldown >= 60 then
					cd = format("%.1f h", (cooldown / 60))
				end
				menu.text = string.format('2. %s (%s)', creatureName, cd)
				menu.colorCode = "|cff848484"
			end
			if issummoned then
				menu.colorCode = "|cff00ff00"
			end
			UIDropDownMenu_AddButton(menu, level)
		end
		if fav3index ~= nil then
		local creatureID, creatureName, creatureSpellID, icon, issummoned = GetCompanionInfo("CRITTER", fav3index)
		local isUsable, notEnoughMana = IsUsableSpell(creatureSpellID)
		local startTime, duration, isEnabled = GetCompanionCooldown("CRITTER", fav3index)	
			menu.text = format("3. %s", fav3name)
			menu.icon = fav3icon
			menu.colorCode = "|cffffffff"
			menu.func = ModifiedClick
			menu.arg1 = fav3index
			menu.hasArrow = nil;
			menu.notCheckable = 1
			if not isUsable then
				menu.colorCode = "|cff848484"
			end
			if duration > 1.5 then
				cooldown = floor(((startTime + duration) - GetTime()) / 60)
				cd = format("%d m", cooldown)
				if cooldown >= 60 then
					cd = format("%.1f h", (cooldown / 60))
				end
				menu.text = string.format('3. %s (%s)', creatureName, cd)
				menu.colorCode = "|cff848484"
			end
			if issummoned then
				menu.colorCode = "|cff00ff00"
			end
			UIDropDownMenu_AddButton(menu, level)
		end
	end
	if (level == 2) then
	 -- getting values of first menu
    local Level1_Key = UIDROPDOWNMENU_MENU_VALUE["Level1_Key"];
		
    for i = 1, GetNumCompanions("CRITTER") do
		
		local creatureID, creatureName, creatureSpellID, icon, issummoned = GetCompanionInfo("CRITTER", i)
		local isUsable, notEnoughMana = IsUsableSpell(creatureSpellID)
		local startTime, duration, isEnabled = GetCompanionCooldown("CRITTER", i)
		firstChar = strupper(strsub(creatureName, 1, 1))

		menu.hasArrow = false; -- Start menu creation
		menu.notCheckable = true;
		menu.text = creatureName
		menu.icon = icon
		menu.colorCode = "|cffffffff"
		menu.func = ModifiedClick
		menu.arg1 = i
		
		if not isUsable then
			menu.colorCode = "|cff848484"
		end
		if duration > 1.5 then
			cooldown = floor(((startTime + duration) - GetTime()) / 60)
			cd = format("%d m", cooldown)
			if cooldown >= 60 then
				cd = format("%.1f h", (cooldown / 60))
			end
			menu.text = string.format('%s (%s)', creatureName, cd)
			menu.colorCode = "|cff848484"
		end
		if issummoned then
			menu.colorCode = "|cff00ff00"
		end
		
		
		if firstChar >= "A" and firstChar <= "B" and Level1_Key == "AB" then
			UIDropDownMenu_AddButton(menu, level)
		end
		
		if firstChar >= "C" and firstChar <= "D" and Level1_Key == "CD" then
			UIDropDownMenu_AddButton(menu, level)
		end
		
		if firstChar >= "E" and firstChar <= "F" and Level1_Key == "EF" then
			UIDropDownMenu_AddButton(menu, level)
		end
		
		if firstChar >= "G" and firstChar <= "H" and Level1_Key == "GH" then
			UIDropDownMenu_AddButton(menu, level)
		end
		
		if firstChar >= "I" and firstChar <= "J" and Level1_Key == "IJ" then
			UIDropDownMenu_AddButton(menu, level)
		end
	
		if firstChar >= "K" and firstChar <= "L" and Level1_Key == "KL" then
			UIDropDownMenu_AddButton(menu, level)
		end
		
		if firstChar >= "M" and firstChar <= "N" and Level1_Key == "MN" then
			UIDropDownMenu_AddButton(menu, level)
		end
		
		if firstChar >= "O" and firstChar <= "P" and Level1_Key == "OP" then
			UIDropDownMenu_AddButton(menu, level)
		end
	
		if firstChar >= "Q" and firstChar <= "R" and Level1_Key == "QR" then
			UIDropDownMenu_AddButton(menu, level)
		end
		
		if firstChar >= "S" and firstChar <= "T" and Level1_Key == "ST" then
			UIDropDownMenu_AddButton(menu, level)
		end
		
		if firstChar >= "U" and firstChar <= "V" and Level1_Key == "UV" then
			UIDropDownMenu_AddButton(menu, level)
		end
		
		if firstChar >= "W" and firstChar <= "X" and Level1_Key == "WX" then
			UIDropDownMenu_AddButton(menu, level)
		end
		
		if firstChar >= "Y" and firstChar <= "Z" and Level1_Key == "YZ" then
			UIDropDownMenu_AddButton(menu, level)
		end
		
	end
	end
	end

end


function parent:PLAYER_LOGIN()
	LDB = LibStub('LibDataBroker-1.1'):NewDataObject('BrokerPets', {
		icon = "Interface\\Icons\\INV_Misc_QuestionMark.blp",
		text = "BrokerPets",
		type = 'data source',
		OnTooltipShow = OnTooltipShow,
		OnClick = OnClick,
	})

	self:RegisterEvent('COMPANION_UPDATE')
	self.COMPANION_UPDATE = UpdateDisplay

	self.initialize = CreateMenu
	self.displayMode = 'MENU'

	UpdateDisplay()
end

parent:SetScript('OnEvent', function(self, event, ...) self[event](self, ...) end)
parent:RegisterEvent('PLAYER_LOGIN')